#include "ccglogics.h"

#ifndef _CGLOGICSWINAPI_H_
#define _CGLOGICSWINAPI_H_

#if _MSC_VER > 1000
   #pragma once
#endif

#ifdef __cplusplus
extern "C" {	// only need to export C interface if used by C++ source code
#endif

#ifdef _COMPILING_THE_DLL_
   #define CGLOGICS_API __declspec(dllexport)
#else
   #define CGLOGICS_API __declspec(dllimport)
#endif

// API functions recommended for new integrations
CGLOGICS_API short __stdcall initCG( char* portSettings, char* initSettings, char* message );
CGLOGICS_API short __stdcall registerEvents3CG( void (__cdecl *cgStatusCall)( int amount, short status, short mode ),
											   void (__cdecl *cgErrorCall)( int errorCode, char* errorText, char* extInfo ),
											   void (__cdecl *cgLevelWarningCall)( short warningType, long denomination, short numberOf, char* typeString, char* denominationString, char* warningMessage, char* extInfo ),
											   void (__cdecl *cgCashSessionCall)( short infoType, int amount, char* extInfo ),
											   char* message );
CGLOGICS_API short __stdcall registerEvents4CG(void(__cdecl *cgStatusCall)(int amount, short status, short mode),
												void(__cdecl *cgErrorCall)(int errorCode, char* errorText, char* extInfo),
												void(__cdecl *cgLevelWarningCall)(short warningType, long denomination, short numberOf, char* typeString, char* denominationString, char* warningMessage, char* extInfo),
												void(__cdecl *cgInformationCall)(char* informationMessage),
												void(__cdecl *cgCashSessionCall)(short infoType, int amount, char* extInfo),
												char* message);
CGLOGICS_API short __stdcall exitCG( char* message );
CGLOGICS_API short __stdcall loginStrCG(char* cashRegId, char* cashierId, char* message);
CGLOGICS_API short __stdcall logoutCG( char* message );
CGLOGICS_API short __stdcall isOpenCG( int* open, char* message );
CGLOGICS_API short __stdcall infoCG( int* level, char* commands, char* master, char* info, char* message );
CGLOGICS_API short __stdcall changeCG( char* message );
CGLOGICS_API short __stdcall regretCG( short regretType, char* message );
CGLOGICS_API short __stdcall resetCG( char* message );
CGLOGICS_API short __stdcall cashCountCG(CashInfo*	coinsArray[], int* coinsCount, CashInfo* notesArray[], int* notesCount, char* message);
CGLOGICS_API short __stdcall completeCashCountCG(CashInfo*	coinsArray[], int* coinsCount, CashInfo* notesArray[], int* notesCount, char* message);
CGLOGICS_API short __stdcall adminModeCG(short adminModeType, char* message);
CGLOGICS_API short __stdcall collectToCashFloatCG(short dispenseType, CashInfo* coinsArray[], int* coinsCount, CashInfo* notesArray[], int* notesCount, int* amountRest, char* transactionId, char* message);
CGLOGICS_API short __stdcall endReplenishCG(char* transactionId, char* message);
CGLOGICS_API short __stdcall dispenseSpecifiedCG(short dispenseType, CashInfo*	coinsArray[], int* coinsCount, CashInfo* notesArray[], int* notesCount , int* amountRest, char* transactionId, char* message);
CGLOGICS_API short __stdcall askPayout2CG( int amountAskPay, int* amountRest, char* message );
CGLOGICS_API short __stdcall changeSettingsCG( char* initSettings, short durationType, char* message );
CGLOGICS_API short __stdcall purgeCG(int key, CashInfo* coinsArray[], int* coinsCount, CashInfo* notesArray[], int* notesCount, int* amountRest, char* transactionId, char* message);
CGLOGICS_API short __stdcall unlockCG(int key, char* message);
// Alternative 1: The traditional functions for depositing/dispensing cash
CGLOGICS_API short __stdcall payout2CG( int amountDispense, int amountDeposit, char* transactId, int* amountRest, char* message );
CGLOGICS_API short __stdcall amountDueCG( int amountDue, char* transactId, int* amountRest, char* message );

// Alternative 2: The new functions for depositing/dispensing cash, with added features to lock/unlock the possibility to insert cash.
// If the functions enable/disable payin are used, the functions deposit/dispense must be used to deposit and dispense cash
// (i.e. the payout and amountDue functions in alternative 1 are not allowed)
CGLOGICS_API short __stdcall enablePayinCG( char* message );
CGLOGICS_API short __stdcall disablePayinCG( char* message );
CGLOGICS_API short __stdcall depositCG( char* transactId, char* message );
CGLOGICS_API short __stdcall dispenseCG( int amountDispense, char* transactId, int* amountRest, char* message );



// Additional API functions available for backwards compatibility with existing integrations
CGLOGICS_API short __stdcall registerEventsCG( void (__cdecl *cgStatusCall)( int amount, short status, short mode ),
											   void (__cdecl *cgErrorCall)( int errorCode, char* errorText, char* extInfo ),
											   void (__cdecl *cgCashLevelCall)( long denomination, short numberOf, char* extInfo ),
											   char* message );
CGLOGICS_API short __stdcall registerEvents2CG( void (__cdecl *cgStatusCall)( int amount, short status, short mode ),
											   void (__cdecl *cgErrorCall)( int errorCode, char* errorText, char* extInfo ),
											   void (__cdecl *cgCashLevelCall)( long denomination, short numberOf, char* extInfo ),
											   void (__cdecl *cgCashSessionCall)( short infoType, int amount, char* extInfo ),
											   char* message );
CGLOGICS_API short __stdcall registerEvents23CG( void (__cdecl *cgStatusCall)( int amount, short status, short mode ),
											   void (__cdecl *cgErrorCall)( int errorCode, char* errorText, char* extInfo ),
											   void (__cdecl *cgCashLevelCall)( long denomination, short numberOf, char* extInfo ),
											   void (__cdecl *cgLevelWarningCall)( short warningType, long denomination, short numberOf, char* typeString, char* denominationString, char* warningMessage, char* extInfo ),
											   void (__cdecl *cgCashSessionCall)( short infoType, int amount, char* extInfo ),
											   char* message );
CGLOGICS_API short __stdcall loginCG(short cashRegId, short cashierId, char* message);
CGLOGICS_API short __stdcall payoutCG( int amountDispense, int amountDeposit, char* transactId, char* message );
CGLOGICS_API short __stdcall askPayoutCG(int amountAskPay, char* message);
CGLOGICS_API short __stdcall informTotalAmountCG( int amountAskPay, char* message );


#ifdef __cplusplus
   }
#endif

#endif
